
/**
	AnAA - Ajax Gears Framework
	Version 1.7
	www.anaa.eu
	(c) 2008 Sandrine Takis and Denis Sureau.
	Free under the GNU GPL 2.0 License.
*/	

var AACaching = true;


function AACreate() 
{
	var xhr = google.gears.factory.create('beta.httprequest');
	if(!xhr)
	{
		try {  xhr = new ActiveXObject('Msxml2.XMLHTTP');   }
		catch (err1) 
		{
			try  {  xhr = new ActiveXObject('Microsoft.XMLHTTP');   }
			catch (err2) 
			{
				try {  xhr = new XMLHttpRequest();   }
				catch (err3) 
				{
					xhr = false;
				}
			}
		}
	}

	return xhr;

}


/**
	AA Read
	Load a file, text or XML
*/	

function AARead(url, fun, element)
{ 
	var xhr = AACreate();
	xhr.onreadystatechange=function()
	{ 
		if(xhr.readyState == 4)
		{
			var content = xhr.responseText;
			fun(content, element);
		} 
	}; 

	if(AACaching == false)
		url = url + "?nocache=" + Math.random();
	xhr.open("GET", url);
	xhr.send(null); 
} 


/**
	AAWrite
	url:	the script
	data:	the string to pass to the script
		it is a list of pairs x=y separated by &
*/	

function AAWrite(url, data, fun)
{ 
	var xhr = AACreate();

	xhr.onreadystatechange=function()
	{ 
		if(xhr.readyState == 4)
		{
			if(fun != null) fun();
		}
	}; 
	xhr.open("POST", url);		
	xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xhr.send(data); 
} 
	

function AAGetBody(content)
{
	var x = content.indexOf("<body");
	if(x == -1) return "";
		
	x = content.indexOf(">", x);
	if(x == -1) return "";

	var y = content.lastIndexOf("</body>");
	if(y == -1) return "";
	
	return content.slice(x + 1, y);
}

function AAPutHTML(content, target)
{
	target.innerHTML = AAGetBody(content);
}

/**
	Loads a HTML page
	Put the content of the body tag into the current page.
	Arguments:
		url of the other HTML page to load
		id of the tag that has to hold the content
*/		

function AALoadHTML(url, fun, storage, param)
{
	var xhr = AACreate();
	xhr.onreadystatechange=function()
	{ 
		if(xhr.readyState == 4)
		{
				storage = document.getElementById(storage);
				storage.innerHTML = AAGetBody(xhr.responseText);
				fun(storage, param);
		} 
	}; 

	xhr.open("GET", url);
	xhr.send(null); 

} 


/**
	Send a HEAD request,
	call a function with the value 
*/

function AAHead(url, key, fun, element)
{ 
	var xhr = AACreate();

	xhr.onreadystatechange = function() 
	{
		if(xhr.readyState == 4) 
		{
			var value = xhr.getResponseHeader(key);
			if(xhr.status==404) 
					value = url + " doesn't exist!";
			else 
					value = "Error, status is " + xhr.status;
			fun(value, element);		
		}
	}
	xhr.open("HEAD", url);
	xhr.send(null); 
} 

